'use strict';
var shapefile = require('shapefile');
var proj4geojson = require('proj4geojson');
var Transform = require('io-stream').Transform;
var fs = require('fs');

var shp = '/Volumes/qroot/Clients/c546.GreenInfoNetwork/USGS-GAP/PAD-US/Data/20140514_PADUS/PAD_US/padusarc10gdb/PADUS_1_3Fee.shp';

var dbf = '/Volumes/qroot/Clients/c546.GreenInfoNetwork/USGS-GAP/PAD-US/Data/20140514_PADUS/PAD_US/padusarc10gdb/PADUS_1_3Fee.dbf';
var prj = fs.readFileSync('/Volumes/qroot/Clients/c546.GreenInfoNetwork/USGS-GAP/PAD-US/Data/20140514_PADUS/PAD_US/padusarc10gdb/PADUS_1_3Fee.prj').toString();
var config = require('./test.config.json');
var cartodb = require('./')(config.username, config.apikey);
shapefile.reader({
  shp: shp,
  dbf: dbf
}).createReadStream().pipe(new Transform({
  objectMode: true,
  transform: function (chunk, _, next) {
    var fc = {
      features: [chunk]
    };
    var out = proj4geojson.toWGS84(fc, prj);
    this.push(out.features[0]);
    next();
  }
})).pipe(cartodb.createWriteStream('pandus_fee_13', {
  create: true
})).on('finish', function (){
  console.log('done');
}).on('end', function (){
  console.log('done');
}).on('error', function (err){
  console.log('on noes', err && err.stack || err);
});
